void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->_TMP_ADD10_OUT,0,retain)
  __INIT_VAR(data__->_TMP_EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->_TMP_SEL15_OUT,0,retain)
  __INIT_VAR(data__->_TMP_AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,_TMP_ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,_TMP_EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,)));
  __SET_VAR(data__->,_TMP_SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (UINT)__GET_VAR(data__->_TMP_ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->_TMP_SEL15_OUT,));
  __SET_VAR(data__->,_TMP_AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->_TMP_EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->_TMP_AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void ARDUINO_PLC_LD_init__(ARDUINO_PLC_LD *data__, BOOL retain) {
  __INIT_VAR(data__->I_BTN_S1_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_S1_B,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_S2_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_S2_B,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR5,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_MILL,1,retain)
  __INIT_VAR(data__->I_DRILL,1,retain)
  __INIT_VAR(data__->Q_SLID1_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLID1_B,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLID2_F,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLID2_B,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_MILL,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_DRILL,__BOOL_LITERAL(FALSE),retain)
  TOF_init__(&data__->TOF0,retain);
  TON_init__(&data__->TON0,retain);
  TOF_init__(&data__->TOF1,retain);
  TON_init__(&data__->TON1,retain);
  TOF_init__(&data__->TOF2,retain);
  TON_init__(&data__->TON2,retain);
  TOF_init__(&data__->TOF3,retain);
  TON_init__(&data__->TON3,retain);
  TOF_init__(&data__->TOF4,retain);
  TON_init__(&data__->TON4,retain);
  TOF_init__(&data__->TOF5,retain);
  TON_init__(&data__->TON5,retain);
  F_TRIG_init__(&data__->F_TRIG1,retain);
  F_TRIG_init__(&data__->F_TRIG2,retain);
  F_TRIG_init__(&data__->F_TRIG3,retain);
  F_TRIG_init__(&data__->F_TRIG4,retain);
}

// Code part
void ARDUINO_PLC_LD_body__(ARDUINO_PLC_LD *data__) {
  // Initialise TEMP variables

  if (!(__GET_VAR(data__->I_SENSOR1,))) {
    __SET_VAR(data__->,Q_CONV1,,__BOOL_LITERAL(TRUE));
  };
  __SET_VAR(data__->TOF0.,IN,,!(__GET_VAR(data__->I_SENSOR2,)));
  __SET_VAR(data__->TOF0.,PT,,__time_to_timespec(1, 900, 0, 0, 0, 0));
  TOF_body__(&data__->TOF0);
  __SET_VAR(data__->TON0.,IN,,__GET_VAR(data__->TOF0.Q,));
  __SET_VAR(data__->TON0.,PT,,__time_to_timespec(1, 700, 0, 0, 0, 0));
  TON_body__(&data__->TON0);
  if (__GET_VAR(data__->TON0.Q,)) {
    __SET_VAR(data__->,Q_CONV1,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->TON0.Q,)) {
    __SET_VAR(data__->,Q_CONV2,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->TON0.Q,)) {
    __SET_VAR(data__->,Q_SLID1_F,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->I_BTN_S1_F,)) {
    __SET_VAR(data__->,Q_SLID1_F,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->I_BTN_S1_F,)) {
    __SET_VAR(data__->,Q_SLID1_B,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->I_BTN_S1_B,)) {
    __SET_VAR(data__->,Q_SLID1_B,,__BOOL_LITERAL(FALSE));
  };
  __SET_VAR(data__->F_TRIG1.,CLK,,__GET_VAR(data__->I_SENSOR3,));
  F_TRIG_body__(&data__->F_TRIG1);
  __SET_VAR(data__->TOF1.,IN,,(__GET_VAR(data__->I_MILL,) && __GET_VAR(data__->F_TRIG1.Q,)));
  __SET_VAR(data__->TOF1.,PT,,__time_to_timespec(1, 3000, 0, 0, 0, 0));
  TOF_body__(&data__->TOF1);
  if (__GET_VAR(data__->TOF1.Q,)) {
    __SET_VAR(data__->,Q_MILL,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->TOF1.Q,)) {
    __SET_VAR(data__->,Q_CONV2,,__BOOL_LITERAL(FALSE));
  };
  __SET_VAR(data__->F_TRIG2.,CLK,,__GET_VAR(data__->I_SENSOR3,));
  F_TRIG_body__(&data__->F_TRIG2);
  __SET_VAR(data__->TON1.,IN,,__GET_VAR(data__->TOF1.Q,));
  __SET_VAR(data__->TON1.,PT,,__time_to_timespec(1, 2900, 0, 0, 0, 0));
  TON_body__(&data__->TON1);
  __SET_VAR(data__->TOF2.,IN,,((!(__GET_VAR(data__->I_MILL,)) && __GET_VAR(data__->F_TRIG2.Q,)) || __GET_VAR(data__->TON1.Q,)));
  __SET_VAR(data__->TOF2.,PT,,__time_to_timespec(1, 1400, 0, 0, 0, 0));
  TOF_body__(&data__->TOF2);
  if (__GET_VAR(data__->TOF2.Q,)) {
    __SET_VAR(data__->,Q_CONV2,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->TOF2.Q,)) {
    __SET_VAR(data__->,Q_MILL,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->TOF2.Q,)) {
    __SET_VAR(data__->,Q_CONV3,,__BOOL_LITERAL(TRUE));
  };
  __SET_VAR(data__->TON2.,IN,,__GET_VAR(data__->TOF2.Q,));
  __SET_VAR(data__->TON2.,PT,,__time_to_timespec(1, 1300, 0, 0, 0, 0));
  TON_body__(&data__->TON2);
  if (__GET_VAR(data__->TON2.Q,)) {
    __SET_VAR(data__->,Q_CONV2,,__BOOL_LITERAL(FALSE));
  };
  __SET_VAR(data__->F_TRIG3.,CLK,,__GET_VAR(data__->I_SENSOR4,));
  F_TRIG_body__(&data__->F_TRIG3);
  __SET_VAR(data__->TOF3.,IN,,(__GET_VAR(data__->I_DRILL,) && __GET_VAR(data__->F_TRIG3.Q,)));
  __SET_VAR(data__->TOF3.,PT,,__time_to_timespec(1, 3000, 0, 0, 0, 0));
  TOF_body__(&data__->TOF3);
  if (__GET_VAR(data__->TOF3.Q,)) {
    __SET_VAR(data__->,Q_DRILL,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->TOF3.Q,)) {
    __SET_VAR(data__->,Q_CONV3,,__BOOL_LITERAL(FALSE));
  };
  __SET_VAR(data__->F_TRIG4.,CLK,,__GET_VAR(data__->I_SENSOR4,));
  F_TRIG_body__(&data__->F_TRIG4);
  __SET_VAR(data__->TON3.,IN,,__GET_VAR(data__->TOF3.Q,));
  __SET_VAR(data__->TON3.,PT,,__time_to_timespec(1, 2900, 0, 0, 0, 0));
  TON_body__(&data__->TON3);
  __SET_VAR(data__->TOF4.,IN,,((!(__GET_VAR(data__->I_DRILL,)) && __GET_VAR(data__->F_TRIG4.Q,)) || __GET_VAR(data__->TON3.Q,)));
  __SET_VAR(data__->TOF4.,PT,,__time_to_timespec(1, 1500, 0, 0, 0, 0));
  TOF_body__(&data__->TOF4);
  if (__GET_VAR(data__->TOF4.Q,)) {
    __SET_VAR(data__->,Q_DRILL,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->TOF4.Q,)) {
    __SET_VAR(data__->,Q_CONV3,,__BOOL_LITERAL(TRUE));
  };
  __SET_VAR(data__->TON4.,IN,,__GET_VAR(data__->TOF4.Q,));
  __SET_VAR(data__->TON4.,PT,,__time_to_timespec(1, 1400, 0, 0, 0, 0));
  TON_body__(&data__->TON4);
  if (__GET_VAR(data__->TON4.Q,)) {
    __SET_VAR(data__->,Q_CONV3,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->TON4.Q,)) {
    __SET_VAR(data__->,Q_CONV4,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->TON4.Q,)) {
    __SET_VAR(data__->,Q_SLID2_F,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->I_BTN_S2_F,)) {
    __SET_VAR(data__->,Q_SLID2_F,,__BOOL_LITERAL(FALSE));
  };
  if (__GET_VAR(data__->I_BTN_S2_F,)) {
    __SET_VAR(data__->,Q_SLID2_B,,__BOOL_LITERAL(TRUE));
  };
  if (__GET_VAR(data__->I_BTN_S2_B,)) {
    __SET_VAR(data__->,Q_SLID2_B,,__BOOL_LITERAL(FALSE));
  };
  __SET_VAR(data__->TOF5.,IN,,!(__GET_VAR(data__->I_SENSOR5,)));
  __SET_VAR(data__->TOF5.,PT,,__time_to_timespec(1, 700, 0, 0, 0, 0));
  TOF_body__(&data__->TOF5);
  __SET_VAR(data__->TON5.,IN,,__GET_VAR(data__->TOF5.Q,));
  __SET_VAR(data__->TON5.,PT,,__time_to_timespec(1, 500, 0, 0, 0, 0));
  TON_body__(&data__->TON5);
  if (__GET_VAR(data__->TON5.Q,)) {
    __SET_VAR(data__->,Q_CONV4,,__BOOL_LITERAL(FALSE));
  };

  goto __end;

__end:
  return;
} // ARDUINO_PLC_LD_body__() 





