void LOGGER_init__(LOGGER *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->MSG,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->LEVEL,LOGLEVEL__INFO,retain)
  __INIT_VAR(data__->TRIG0,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void LOGGER_body__(LOGGER *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  if ((__GET_VAR(data__->TRIG,) && !(__GET_VAR(data__->TRIG0,)))) {
    #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
    #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)

   LogMessage(GetFbVar(LEVEL),(char*)GetFbVar(MSG, .body),GetFbVar(MSG, .len));
  
    #undef GetFbVar
    #undef SetFbVar
;
  };
  __SET_VAR(data__->,TRIG0,,__GET_VAR(data__->TRIG,));

  goto __end;

__end:
  return;
} // LOGGER_body__() 





void PYTHON_EVAL_init__(PYTHON_EVAL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_EVAL_body__(PYTHON_EVAL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(0, data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_EVAL_body__() 





void PYTHON_POLL_init__(PYTHON_POLL *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->STATE,0,retain)
  __INIT_VAR(data__->BUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->PREBUFFER,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->TRIGM1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->TRIGGED,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_POLL_body__(PYTHON_POLL *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __IL_DEFVAR_T __IL_DEFVAR;
  __IL_DEFVAR_T __IL_DEFVAR_BACK;
  #define GetFbVar(var,...) __GET_VAR(data__->var,__VA_ARGS__)
  #define SetFbVar(var,val,...) __SET_VAR(data__->,var,__VA_ARGS__,val)
extern void __PythonEvalFB(int, PYTHON_EVAL*);__PythonEvalFB(1,(PYTHON_EVAL*)(void*)data__);
  #undef GetFbVar
  #undef SetFbVar
;

  goto __end;

__end:
  return;
} // PYTHON_POLL_body__() 





void PYTHON_GEAR_init__(PYTHON_GEAR *data__, BOOL retain) {
  __INIT_VAR(data__->EN,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->ENO,__BOOL_LITERAL(TRUE),retain)
  __INIT_VAR(data__->N,0,retain)
  __INIT_VAR(data__->TRIG,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->CODE,__STRING_LITERAL(0,""),retain)
  __INIT_VAR(data__->ACK,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->RESULT,__STRING_LITERAL(0,""),retain)
  PYTHON_EVAL_init__(&data__->PY_EVAL,retain);
  __INIT_VAR(data__->COUNTER,0,retain)
  __INIT_VAR(data__->ADD10_OUT,0,retain)
  __INIT_VAR(data__->EQ13_OUT,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->SEL15_OUT,0,retain)
  __INIT_VAR(data__->AND7_OUT,__BOOL_LITERAL(FALSE),retain)
}

// Code part
void PYTHON_GEAR_body__(PYTHON_GEAR *data__) {
  // Control execution
  if (!__GET_VAR(data__->EN)) {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(FALSE));
    return;
  }
  else {
    __SET_VAR(data__->,ENO,,__BOOL_LITERAL(TRUE));
  }
  // Initialise TEMP variables

  __SET_VAR(data__->,ADD10_OUT,,ADD__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->COUNTER,),
    (UINT)1));
  __SET_VAR(data__->,EQ13_OUT,,EQ__BOOL__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (UINT)__GET_VAR(data__->N,),
    (UINT)__GET_VAR(data__->ADD10_OUT,)));
  __SET_VAR(data__->,SEL15_OUT,,SEL__UINT__BOOL__UINT__UINT(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (UINT)__GET_VAR(data__->ADD10_OUT,),
    (UINT)0));
  __SET_VAR(data__->,COUNTER,,__GET_VAR(data__->SEL15_OUT,));
  __SET_VAR(data__->,AND7_OUT,,AND__BOOL__BOOL(
    (BOOL)__BOOL_LITERAL(TRUE),
    NULL,
    (UINT)2,
    (BOOL)__GET_VAR(data__->EQ13_OUT,),
    (BOOL)__GET_VAR(data__->TRIG,)));
  __SET_VAR(data__->PY_EVAL.,TRIG,,__GET_VAR(data__->AND7_OUT,));
  __SET_VAR(data__->PY_EVAL.,CODE,,__GET_VAR(data__->CODE,));
  PYTHON_EVAL_body__(&data__->PY_EVAL);
  __SET_VAR(data__->,ACK,,__GET_VAR(data__->PY_EVAL.ACK,));
  __SET_VAR(data__->,RESULT,,__GET_VAR(data__->PY_EVAL.RESULT,));

  goto __end;

__end:
  return;
} // PYTHON_GEAR_body__() 





void SFC_TEST1_init__(SFC_TEST1 *data__, BOOL retain) {
  __INIT_VAR(data__->I_SENSOR1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_SENSOR5,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_LEFT1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_LEFT2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_RIGHT1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_BTN_RIGHT2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV1,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV2,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV3,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_CONV4,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLIDER1_FORWARD,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLIDER1_BACKWARD,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLIDER2_FORWARD,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_SLIDER2_BACKWARD,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_MILLING,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->Q_DRILLING,__BOOL_LITERAL(FALSE),retain)
  __INIT_VAR(data__->I_MILLING,1,retain)
  __INIT_VAR(data__->I_DRILLING,1,retain)
  TON_init__(&data__->TON0,retain);
  TON_init__(&data__->TON1,retain);
  TOF_init__(&data__->TOF0,retain);
  TOF_init__(&data__->TOF1,retain);
  __INIT_VAR(data__->START_TIMER_CONV3,0,retain)
  __INIT_VAR(data__->START_TIMER_MILL,0,retain)
  __INIT_VAR(data__->START_TIMER_DRILL,0,retain)
  TON_init__(&data__->TON2,retain);
  TOF_init__(&data__->TOF2,retain);
  TON_init__(&data__->TON3,retain);
  TOF_init__(&data__->TOF3,retain);
  UINT i;
  data__->__nb_steps = 22;
  static const STEP temp_step = {{0, 0}, 0, {{0, 0}, 0}};
  for(i = 0; i < data__->__nb_steps; i++) {
    data__->__step_list[i] = temp_step;
  }
  __SET_VAR(data__->,__step_list[0].X,,1);
  data__->__nb_actions = 14;
  static const ACTION temp_action = {0, {0, 0}, 0, 0, {0, 0}, {0, 0}};
  for(i = 0; i < data__->__nb_actions; i++) {
    data__->__action_list[i] = temp_action;
  }
  data__->__nb_transitions = 24;
  data__->__lasttick_time = __CURRENT_TIME;
}

// Steps definitions
#define STEP0 __step_list[0]
#define __SFC_STEP0 0
#define STEP1 __step_list[1]
#define __SFC_STEP1 1
#define STEP2 __step_list[2]
#define __SFC_STEP2 2
#define STEP3 __step_list[3]
#define __SFC_STEP3 3
#define STEP4 __step_list[4]
#define __SFC_STEP4 4
#define STEP5 __step_list[5]
#define __SFC_STEP5 5
#define STEP6 __step_list[6]
#define __SFC_STEP6 6
#define STEP7 __step_list[7]
#define __SFC_STEP7 7
#define STEP8 __step_list[8]
#define __SFC_STEP8 8
#define STEP9 __step_list[9]
#define __SFC_STEP9 9
#define STEP10 __step_list[10]
#define __SFC_STEP10 10
#define STEP11 __step_list[11]
#define __SFC_STEP11 11
#define STEP12 __step_list[12]
#define __SFC_STEP12 12
#define STEP13 __step_list[13]
#define __SFC_STEP13 13
#define STEP14 __step_list[14]
#define __SFC_STEP14 14
#define STEP15 __step_list[15]
#define __SFC_STEP15 15
#define STEP16 __step_list[16]
#define __SFC_STEP16 16
#define STEP17 __step_list[17]
#define __SFC_STEP17 17
#define STEP18 __step_list[18]
#define __SFC_STEP18 18
#define STEP19 __step_list[19]
#define __SFC_STEP19 19
#define STEP20 __step_list[20]
#define __SFC_STEP20 20
#define STEP21 __step_list[21]
#define __SFC_STEP21 21

// Actions definitions
#define __SFC_COMPUTE_FUNCTION_BLOCKS 0
#define __SFC_Q_CONV1 1
#define __SFC_Q_SLIDER1_FORWARD 2
#define __SFC_Q_CONV2 3
#define __SFC_Q_SLIDER1_BACKWARD 4
#define __SFC_Q_MILLING 5
#define __SFC_START_TIMER_MILL 6
#define __SFC_Q_CONV3 7
#define __SFC_Q_DRILLING 8
#define __SFC_START_TIMER_DRILL 9
#define __SFC_START_TIMER_CONV3 10
#define __SFC_Q_SLIDER2_FORWARD 11
#define __SFC_Q_CONV4 12
#define __SFC_Q_SLIDER2_BACKWARD 13

// Code part
void SFC_TEST1_body__(SFC_TEST1 *data__) {
  // Initialise TEMP variables

  INT i;
  TIME elapsed_time, current_time;

  // Calculate elapsed_time
  current_time = __CURRENT_TIME;
  elapsed_time = __time_sub(current_time, data__->__lasttick_time);
  data__->__lasttick_time = current_time;
  // Transitions initialization
  if (__DEBUG) {
    for (i = 0; i < data__->__nb_transitions; i++) {
      data__->__transition_list[i] = data__->__debug_transition_list[i];
    }
  }
  // Steps initialization
  for (i = 0; i < data__->__nb_steps; i++) {
    data__->__step_list[i].prev_state = __GET_VAR(data__->__step_list[i].X);
    if (__GET_VAR(data__->__step_list[i].X)) {
      data__->__step_list[i].T.value = __time_add(data__->__step_list[i].T.value, elapsed_time);
    }
  }
  // Actions initialization
  for (i = 0; i < data__->__nb_actions; i++) {
    __SET_VAR(data__->,__action_list[i].state,,0);
    data__->__action_list[i].set = 0;
    data__->__action_list[i].reset = 0;
    if (__time_cmp(data__->__action_list[i].set_remaining_time, __time_to_timespec(1, 0, 0, 0, 0, 0)) > 0) {
      data__->__action_list[i].set_remaining_time = __time_sub(data__->__action_list[i].set_remaining_time, elapsed_time);
      if (__time_cmp(data__->__action_list[i].set_remaining_time, __time_to_timespec(1, 0, 0, 0, 0, 0)) <= 0) {
        data__->__action_list[i].set_remaining_time = __time_to_timespec(1, 0, 0, 0, 0, 0);
        data__->__action_list[i].set = 1;
      }
    }
    if (__time_cmp(data__->__action_list[i].reset_remaining_time, __time_to_timespec(1, 0, 0, 0, 0, 0)) > 0) {
      data__->__action_list[i].reset_remaining_time = __time_sub(data__->__action_list[i].reset_remaining_time, elapsed_time);
      if (__time_cmp(data__->__action_list[i].reset_remaining_time, __time_to_timespec(1, 0, 0, 0, 0, 0)) <= 0) {
        data__->__action_list[i].reset_remaining_time = __time_to_timespec(1, 0, 0, 0, 0, 0);
        data__->__action_list[i].reset = 1;
      }
    }
  }

  // Transitions fire test
  if (__GET_VAR(data__->STEP0.X)) {
    __SET_VAR(data__->,__transition_list[0],,!(__GET_VAR(data__->I_SENSOR1,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[0],,__GET_VAR(data__->__transition_list[0]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[0],,!(__GET_VAR(data__->I_SENSOR1,)));
    }
    __SET_VAR(data__->,__transition_list[0],,0);
  }
  if (__GET_VAR(data__->STEP1.X)) {
    __SET_VAR(data__->,__transition_list[1],,__GET_VAR(data__->TON0.Q,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[1],,__GET_VAR(data__->__transition_list[1]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[1],,__GET_VAR(data__->TON0.Q,));
    }
    __SET_VAR(data__->,__transition_list[1],,0);
  }
  if (__GET_VAR(data__->STEP2.X)) {
    __SET_VAR(data__->,__transition_list[2],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[2],,__GET_VAR(data__->__transition_list[2]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[2],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[2],,0);
  }
  if (__GET_VAR(data__->STEP3.X)) {
    __SET_VAR(data__->,__transition_list[3],,__GET_VAR(data__->I_BTN_LEFT1,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[3],,__GET_VAR(data__->__transition_list[3]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[3],,__GET_VAR(data__->I_BTN_LEFT1,));
    }
    __SET_VAR(data__->,__transition_list[3],,0);
  }
  if (__GET_VAR(data__->STEP4.X)) {
    __SET_VAR(data__->,__transition_list[4],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[4],,__GET_VAR(data__->__transition_list[4]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[4],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[4],,0);
  }
  if (__GET_VAR(data__->STEP5.X)) {
    __SET_VAR(data__->,__transition_list[5],,!(__GET_VAR(data__->I_SENSOR3,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[5],,__GET_VAR(data__->__transition_list[5]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[5],,!(__GET_VAR(data__->I_SENSOR3,)));
    }
    __SET_VAR(data__->,__transition_list[5],,0);
  }
  if (__GET_VAR(data__->STEP6.X)) {
    __SET_VAR(data__->,__transition_list[6],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[6],,__GET_VAR(data__->__transition_list[6]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[6],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[6],,0);
  }
  if (__GET_VAR(data__->STEP7.X)) {
    __SET_VAR(data__->,__transition_list[7],,__GET_VAR(data__->I_BTN_LEFT2,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[7],,__GET_VAR(data__->__transition_list[7]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[7],,__GET_VAR(data__->I_BTN_LEFT2,));
    }
    __SET_VAR(data__->,__transition_list[7],,0);
  }
  if (__GET_VAR(data__->STEP8.X)) {
    __SET_VAR(data__->,__transition_list[8],,__GET_VAR(data__->I_MILLING,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[8],,__GET_VAR(data__->__transition_list[8]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[8],,__GET_VAR(data__->I_MILLING,));
    }
    __SET_VAR(data__->,__transition_list[8],,0);
  }
  if (__GET_VAR(data__->STEP9.X)) {
    __SET_VAR(data__->,__transition_list[9],,__GET_VAR(data__->TON2.Q,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[9],,__GET_VAR(data__->__transition_list[9]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[9],,__GET_VAR(data__->TON2.Q,));
    }
    __SET_VAR(data__->,__transition_list[9],,0);
  }
  if (__GET_VAR(data__->STEP10.X)) {
    __SET_VAR(data__->,__transition_list[10],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[10],,__GET_VAR(data__->__transition_list[10]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[10],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[10],,0);
  }
  if (__GET_VAR(data__->STEP11.X)) {
    __SET_VAR(data__->,__transition_list[11],,!(__GET_VAR(data__->I_SENSOR4,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[11],,__GET_VAR(data__->__transition_list[11]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[11],,!(__GET_VAR(data__->I_SENSOR4,)));
    }
    __SET_VAR(data__->,__transition_list[11],,0);
  }
  if (__GET_VAR(data__->STEP12.X)) {
    __SET_VAR(data__->,__transition_list[12],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[12],,__GET_VAR(data__->__transition_list[12]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[12],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[12],,0);
  }
  if (__GET_VAR(data__->STEP13.X)) {
    __SET_VAR(data__->,__transition_list[13],,__GET_VAR(data__->I_DRILLING,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[13],,__GET_VAR(data__->__transition_list[13]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[13],,__GET_VAR(data__->I_DRILLING,));
    }
    __SET_VAR(data__->,__transition_list[13],,0);
  }
  if (__GET_VAR(data__->STEP14.X)) {
    __SET_VAR(data__->,__transition_list[14],,__GET_VAR(data__->TON3.Q,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[14],,__GET_VAR(data__->__transition_list[14]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[14],,__GET_VAR(data__->TON3.Q,));
    }
    __SET_VAR(data__->,__transition_list[14],,0);
  }
  if (__GET_VAR(data__->STEP15.X)) {
    __SET_VAR(data__->,__transition_list[15],,__GET_VAR(data__->TON1.Q,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[15],,__GET_VAR(data__->__transition_list[15]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[15],,__GET_VAR(data__->TON1.Q,));
    }
    __SET_VAR(data__->,__transition_list[15],,0);
  }
  if (__GET_VAR(data__->STEP16.X)) {
    __SET_VAR(data__->,__transition_list[16],,__GET_VAR(data__->I_BTN_RIGHT1,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[16],,__GET_VAR(data__->__transition_list[16]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[16],,__GET_VAR(data__->I_BTN_RIGHT1,));
    }
    __SET_VAR(data__->,__transition_list[16],,0);
  }
  if (__GET_VAR(data__->STEP17.X)) {
    __SET_VAR(data__->,__transition_list[17],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[17],,__GET_VAR(data__->__transition_list[17]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[17],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[17],,0);
  }
  if (__GET_VAR(data__->STEP18.X)) {
    __SET_VAR(data__->,__transition_list[18],,!(__GET_VAR(data__->I_SENSOR5,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[18],,__GET_VAR(data__->__transition_list[18]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[18],,!(__GET_VAR(data__->I_SENSOR5,)));
    }
    __SET_VAR(data__->,__transition_list[18],,0);
  }
  if (__GET_VAR(data__->STEP19.X)) {
    __SET_VAR(data__->,__transition_list[19],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[19],,__GET_VAR(data__->__transition_list[19]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[19],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[19],,0);
  }
  if (__GET_VAR(data__->STEP20.X)) {
    __SET_VAR(data__->,__transition_list[20],,__GET_VAR(data__->I_BTN_RIGHT2,));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[20],,__GET_VAR(data__->__transition_list[20]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[20],,__GET_VAR(data__->I_BTN_RIGHT2,));
    }
    __SET_VAR(data__->,__transition_list[20],,0);
  }
  if (__GET_VAR(data__->STEP21.X)) {
    __SET_VAR(data__->,__transition_list[21],,__BOOL_LITERAL(TRUE));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[21],,__GET_VAR(data__->__transition_list[21]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[21],,__BOOL_LITERAL(TRUE));
    }
    __SET_VAR(data__->,__transition_list[21],,0);
  }
  if (__GET_VAR(data__->STEP13.X)) {
    __SET_VAR(data__->,__transition_list[22],,!(__GET_VAR(data__->I_DRILLING,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[22],,__GET_VAR(data__->__transition_list[22]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[22],,!(__GET_VAR(data__->I_DRILLING,)));
    }
    __SET_VAR(data__->,__transition_list[22],,0);
  }
  if (__GET_VAR(data__->STEP8.X)) {
    __SET_VAR(data__->,__transition_list[23],,!(__GET_VAR(data__->I_MILLING,)));
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[23],,__GET_VAR(data__->__transition_list[23]));
    }
  }
  else {
    if (__DEBUG) {
      __SET_VAR(data__->,__debug_transition_list[23],,!(__GET_VAR(data__->I_MILLING,)));
    }
    __SET_VAR(data__->,__transition_list[23],,0);
  }

  // Transitions reset steps
  if (__GET_VAR(data__->__transition_list[0])) {
    __SET_VAR(data__->,STEP0.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[1])) {
    __SET_VAR(data__->,STEP1.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[2])) {
    __SET_VAR(data__->,STEP2.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[3])) {
    __SET_VAR(data__->,STEP3.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[4])) {
    __SET_VAR(data__->,STEP4.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[5])) {
    __SET_VAR(data__->,STEP5.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[6])) {
    __SET_VAR(data__->,STEP6.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[7])) {
    __SET_VAR(data__->,STEP7.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[8])) {
    __SET_VAR(data__->,STEP8.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[9])) {
    __SET_VAR(data__->,STEP9.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[10])) {
    __SET_VAR(data__->,STEP10.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[11])) {
    __SET_VAR(data__->,STEP11.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[12])) {
    __SET_VAR(data__->,STEP12.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[13])) {
    __SET_VAR(data__->,STEP13.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[14])) {
    __SET_VAR(data__->,STEP14.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[15])) {
    __SET_VAR(data__->,STEP15.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[16])) {
    __SET_VAR(data__->,STEP16.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[17])) {
    __SET_VAR(data__->,STEP17.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[18])) {
    __SET_VAR(data__->,STEP18.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[19])) {
    __SET_VAR(data__->,STEP19.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[20])) {
    __SET_VAR(data__->,STEP20.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[21])) {
    __SET_VAR(data__->,STEP21.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[22])) {
    __SET_VAR(data__->,STEP13.X,,0);
  }
  if (__GET_VAR(data__->__transition_list[23])) {
    __SET_VAR(data__->,STEP8.X,,0);
  }

  // Transitions set steps
  if (__GET_VAR(data__->__transition_list[0])) {
    __SET_VAR(data__->,STEP1.X,,1);
    data__->STEP1.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[1])) {
    __SET_VAR(data__->,STEP2.X,,1);
    data__->STEP2.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[2])) {
    __SET_VAR(data__->,STEP3.X,,1);
    data__->STEP3.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[3])) {
    __SET_VAR(data__->,STEP4.X,,1);
    data__->STEP4.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[4])) {
    __SET_VAR(data__->,STEP5.X,,1);
    data__->STEP5.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[5])) {
    __SET_VAR(data__->,STEP6.X,,1);
    data__->STEP6.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[6])) {
    __SET_VAR(data__->,STEP7.X,,1);
    data__->STEP7.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[7])) {
    __SET_VAR(data__->,STEP8.X,,1);
    data__->STEP8.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[8])) {
    __SET_VAR(data__->,STEP9.X,,1);
    data__->STEP9.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[9])) {
    __SET_VAR(data__->,STEP10.X,,1);
    data__->STEP10.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[10])) {
    __SET_VAR(data__->,STEP11.X,,1);
    data__->STEP11.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[11])) {
    __SET_VAR(data__->,STEP12.X,,1);
    data__->STEP12.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[12])) {
    __SET_VAR(data__->,STEP13.X,,1);
    data__->STEP13.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[13])) {
    __SET_VAR(data__->,STEP14.X,,1);
    data__->STEP14.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[14])) {
    __SET_VAR(data__->,STEP15.X,,1);
    data__->STEP15.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[15])) {
    __SET_VAR(data__->,STEP16.X,,1);
    data__->STEP16.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[16])) {
    __SET_VAR(data__->,STEP17.X,,1);
    data__->STEP17.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[17])) {
    __SET_VAR(data__->,STEP18.X,,1);
    data__->STEP18.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[18])) {
    __SET_VAR(data__->,STEP19.X,,1);
    data__->STEP19.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[19])) {
    __SET_VAR(data__->,STEP20.X,,1);
    data__->STEP20.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[20])) {
    __SET_VAR(data__->,STEP21.X,,1);
    data__->STEP21.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[21])) {
    __SET_VAR(data__->,STEP0.X,,1);
    data__->STEP0.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[22])) {
    __SET_VAR(data__->,STEP15.X,,1);
    data__->STEP15.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }
  if (__GET_VAR(data__->__transition_list[23])) {
    __SET_VAR(data__->,STEP10.X,,1);
    data__->STEP10.T.value = __time_to_timespec(1, 0, 0, 0, 0, 0);
  }

  // Steps association
  // STEP0 action associations
  {
    char active = __GET_VAR(data__->STEP0.X);
    char activated = active && !data__->STEP0.prev_state;
    char desactivated = !active && data__->STEP0.prev_state;

    if (active)       {data__->__action_list[__SFC_COMPUTE_FUNCTION_BLOCKS].set = 1;}

  }

  // STEP1 action associations
  {
    char active = __GET_VAR(data__->STEP1.X);
    char activated = active && !data__->STEP1.prev_state;
    char desactivated = !active && data__->STEP1.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV1].set = 1;}

  }

  // STEP2 action associations
  {
    char active = __GET_VAR(data__->STEP2.X);
    char activated = active && !data__->STEP2.prev_state;
    char desactivated = !active && data__->STEP2.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV1].reset = 1;}

  }

  // STEP3 action associations
  {
    char active = __GET_VAR(data__->STEP3.X);
    char activated = active && !data__->STEP3.prev_state;
    char desactivated = !active && data__->STEP3.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER1_FORWARD].set = 1;}

  }

  // STEP4 action associations
  {
    char active = __GET_VAR(data__->STEP4.X);
    char activated = active && !data__->STEP4.prev_state;
    char desactivated = !active && data__->STEP4.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER1_FORWARD].reset = 1;}

  }

  // STEP5 action associations
  {
    char active = __GET_VAR(data__->STEP5.X);
    char activated = active && !data__->STEP5.prev_state;
    char desactivated = !active && data__->STEP5.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV2].set = 1;}

  }

  // STEP6 action associations
  {
    char active = __GET_VAR(data__->STEP6.X);
    char activated = active && !data__->STEP6.prev_state;
    char desactivated = !active && data__->STEP6.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV2].reset = 1;}

  }

  // STEP7 action associations
  {
    char active = __GET_VAR(data__->STEP7.X);
    char activated = active && !data__->STEP7.prev_state;
    char desactivated = !active && data__->STEP7.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER1_BACKWARD].set = 1;}

  }

  // STEP8 action associations
  {
    char active = __GET_VAR(data__->STEP8.X);
    char activated = active && !data__->STEP8.prev_state;
    char desactivated = !active && data__->STEP8.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER1_BACKWARD].reset = 1;}

  }

  // STEP9 action associations
  {
    char active = __GET_VAR(data__->STEP9.X);
    char activated = active && !data__->STEP9.prev_state;
    char desactivated = !active && data__->STEP9.prev_state;

    if (active)       {__SET_VAR(data__->,Q_MILLING,,1);};
    if (desactivated) {__SET_VAR(data__->,Q_MILLING,,0);};

    if (active)       {__SET_VAR(data__->,START_TIMER_MILL,,1);};
    if (desactivated) {__SET_VAR(data__->,START_TIMER_MILL,,0);};

  }

  // STEP10 action associations
  {
    char active = __GET_VAR(data__->STEP10.X);
    char activated = active && !data__->STEP10.prev_state;
    char desactivated = !active && data__->STEP10.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV2].set = 1;}

  }

  // STEP11 action associations
  {
    char active = __GET_VAR(data__->STEP11.X);
    char activated = active && !data__->STEP11.prev_state;
    char desactivated = !active && data__->STEP11.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV3].set = 1;}

  }

  // STEP12 action associations
  {
    char active = __GET_VAR(data__->STEP12.X);
    char activated = active && !data__->STEP12.prev_state;
    char desactivated = !active && data__->STEP12.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV3].reset = 1;}

  }

  // STEP13 action associations
  {
    char active = __GET_VAR(data__->STEP13.X);
    char activated = active && !data__->STEP13.prev_state;
    char desactivated = !active && data__->STEP13.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV2].reset = 1;}

  }

  // STEP14 action associations
  {
    char active = __GET_VAR(data__->STEP14.X);
    char activated = active && !data__->STEP14.prev_state;
    char desactivated = !active && data__->STEP14.prev_state;

    if (active)       {__SET_VAR(data__->,Q_DRILLING,,1);};
    if (desactivated) {__SET_VAR(data__->,Q_DRILLING,,0);};

    if (active)       {__SET_VAR(data__->,START_TIMER_DRILL,,1);};
    if (desactivated) {__SET_VAR(data__->,START_TIMER_DRILL,,0);};

  }

  // STEP15 action associations
  {
    char active = __GET_VAR(data__->STEP15.X);
    char activated = active && !data__->STEP15.prev_state;
    char desactivated = !active && data__->STEP15.prev_state;

    if (active && __time_cmp(data__->STEP15.T.value, __time_to_timespec(1, 1500, 0, 0, 0, 0)) < 0) 
                      {__SET_VAR(data__->,Q_CONV3,,1);}
    else if (desactivated || active)
                      {__SET_VAR(data__->,Q_CONV3,,0);};

    if (active)       {__SET_VAR(data__->,START_TIMER_CONV3,,1);};
    if (desactivated) {__SET_VAR(data__->,START_TIMER_CONV3,,0);};

  }

  // STEP16 action associations
  {
    char active = __GET_VAR(data__->STEP16.X);
    char activated = active && !data__->STEP16.prev_state;
    char desactivated = !active && data__->STEP16.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER2_FORWARD].set = 1;}

  }

  // STEP17 action associations
  {
    char active = __GET_VAR(data__->STEP17.X);
    char activated = active && !data__->STEP17.prev_state;
    char desactivated = !active && data__->STEP17.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER2_FORWARD].reset = 1;}

  }

  // STEP18 action associations
  {
    char active = __GET_VAR(data__->STEP18.X);
    char activated = active && !data__->STEP18.prev_state;
    char desactivated = !active && data__->STEP18.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV4].set = 1;}

  }

  // STEP19 action associations
  {
    char active = __GET_VAR(data__->STEP19.X);
    char activated = active && !data__->STEP19.prev_state;
    char desactivated = !active && data__->STEP19.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_CONV4].reset = 1;}

  }

  // STEP20 action associations
  {
    char active = __GET_VAR(data__->STEP20.X);
    char activated = active && !data__->STEP20.prev_state;
    char desactivated = !active && data__->STEP20.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER2_BACKWARD].set = 1;}

  }

  // STEP21 action associations
  {
    char active = __GET_VAR(data__->STEP21.X);
    char activated = active && !data__->STEP21.prev_state;
    char desactivated = !active && data__->STEP21.prev_state;

    if (active)       {data__->__action_list[__SFC_Q_SLIDER2_BACKWARD].reset = 1;}

  }


  // Actions state evaluation
  for (i = 0; i < data__->__nb_actions; i++) {
    if (data__->__action_list[i].set) {
      data__->__action_list[i].set_remaining_time = __time_to_timespec(1, 0, 0, 0, 0, 0);
      data__->__action_list[i].stored = 1;
    }
    if (data__->__action_list[i].reset) {
      data__->__action_list[i].reset_remaining_time = __time_to_timespec(1, 0, 0, 0, 0, 0);
      data__->__action_list[i].stored = 0;
    }
    __SET_VAR(data__->,__action_list[i].state,,__GET_VAR(data__->__action_list[i].state) | data__->__action_list[i].stored);
  }

  // Actions execution
  if (data__->__action_list[__SFC_Q_CONV1].reset) {
    __SET_VAR(data__->,Q_CONV1,,0);
  }
  else if (data__->__action_list[__SFC_Q_CONV1].set) {
    __SET_VAR(data__->,Q_CONV1,,1);
  }
  if (data__->__action_list[__SFC_Q_SLIDER1_FORWARD].reset) {
    __SET_VAR(data__->,Q_SLIDER1_FORWARD,,0);
  }
  else if (data__->__action_list[__SFC_Q_SLIDER1_FORWARD].set) {
    __SET_VAR(data__->,Q_SLIDER1_FORWARD,,1);
  }
  if (data__->__action_list[__SFC_Q_CONV2].reset) {
    __SET_VAR(data__->,Q_CONV2,,0);
  }
  else if (data__->__action_list[__SFC_Q_CONV2].set) {
    __SET_VAR(data__->,Q_CONV2,,1);
  }
  if (data__->__action_list[__SFC_Q_SLIDER1_BACKWARD].reset) {
    __SET_VAR(data__->,Q_SLIDER1_BACKWARD,,0);
  }
  else if (data__->__action_list[__SFC_Q_SLIDER1_BACKWARD].set) {
    __SET_VAR(data__->,Q_SLIDER1_BACKWARD,,1);
  }
  if (data__->__action_list[__SFC_Q_MILLING].reset) {
    __SET_VAR(data__->,Q_MILLING,,0);
  }
  else if (data__->__action_list[__SFC_Q_MILLING].set) {
    __SET_VAR(data__->,Q_MILLING,,1);
  }
  if (data__->__action_list[__SFC_START_TIMER_MILL].reset) {
    __SET_VAR(data__->,START_TIMER_MILL,,0);
  }
  else if (data__->__action_list[__SFC_START_TIMER_MILL].set) {
    __SET_VAR(data__->,START_TIMER_MILL,,1);
  }
  if (data__->__action_list[__SFC_Q_CONV3].reset) {
    __SET_VAR(data__->,Q_CONV3,,0);
  }
  else if (data__->__action_list[__SFC_Q_CONV3].set) {
    __SET_VAR(data__->,Q_CONV3,,1);
  }
  if (data__->__action_list[__SFC_Q_DRILLING].reset) {
    __SET_VAR(data__->,Q_DRILLING,,0);
  }
  else if (data__->__action_list[__SFC_Q_DRILLING].set) {
    __SET_VAR(data__->,Q_DRILLING,,1);
  }
  if (data__->__action_list[__SFC_START_TIMER_DRILL].reset) {
    __SET_VAR(data__->,START_TIMER_DRILL,,0);
  }
  else if (data__->__action_list[__SFC_START_TIMER_DRILL].set) {
    __SET_VAR(data__->,START_TIMER_DRILL,,1);
  }
  if (data__->__action_list[__SFC_START_TIMER_CONV3].reset) {
    __SET_VAR(data__->,START_TIMER_CONV3,,0);
  }
  else if (data__->__action_list[__SFC_START_TIMER_CONV3].set) {
    __SET_VAR(data__->,START_TIMER_CONV3,,1);
  }
  if (data__->__action_list[__SFC_Q_SLIDER2_FORWARD].reset) {
    __SET_VAR(data__->,Q_SLIDER2_FORWARD,,0);
  }
  else if (data__->__action_list[__SFC_Q_SLIDER2_FORWARD].set) {
    __SET_VAR(data__->,Q_SLIDER2_FORWARD,,1);
  }
  if (data__->__action_list[__SFC_Q_CONV4].reset) {
    __SET_VAR(data__->,Q_CONV4,,0);
  }
  else if (data__->__action_list[__SFC_Q_CONV4].set) {
    __SET_VAR(data__->,Q_CONV4,,1);
  }
  if (data__->__action_list[__SFC_Q_SLIDER2_BACKWARD].reset) {
    __SET_VAR(data__->,Q_SLIDER2_BACKWARD,,0);
  }
  else if (data__->__action_list[__SFC_Q_SLIDER2_BACKWARD].set) {
    __SET_VAR(data__->,Q_SLIDER2_BACKWARD,,1);
  }
  if(__GET_VAR(data__->__action_list[__SFC_COMPUTE_FUNCTION_BLOCKS].state)) {
    __SET_VAR(data__->TOF0.,IN,,!(__GET_VAR(data__->I_SENSOR2,)));
    __SET_VAR(data__->TOF0.,PT,,__time_to_timespec(1, 1500, 0, 0, 0, 0));
    TOF_body__(&data__->TOF0);
    __SET_VAR(data__->TON0.,IN,,__GET_VAR(data__->TOF0.Q,));
    __SET_VAR(data__->TON0.,PT,,__time_to_timespec(1, 1200, 0, 0, 0, 0));
    TON_body__(&data__->TON0);
    __SET_VAR(data__->TOF2.,IN,,__GET_VAR(data__->START_TIMER_MILL,));
    __SET_VAR(data__->TOF2.,PT,,__time_to_timespec(1, 1200, 0, 0, 0, 0));
    TOF_body__(&data__->TOF2);
    __SET_VAR(data__->TON2.,IN,,__GET_VAR(data__->TOF2.Q,));
    __SET_VAR(data__->TON2.,PT,,__time_to_timespec(1, 1000, 0, 0, 0, 0));
    TON_body__(&data__->TON2);
    __SET_VAR(data__->TOF1.,IN,,__GET_VAR(data__->START_TIMER_CONV3,));
    __SET_VAR(data__->TOF1.,PT,,__time_to_timespec(1, 1200, 0, 0, 0, 0));
    TOF_body__(&data__->TOF1);
    __SET_VAR(data__->TON1.,IN,,__GET_VAR(data__->TOF1.Q,));
    __SET_VAR(data__->TON1.,PT,,__time_to_timespec(1, 1000, 0, 0, 0, 0));
    TON_body__(&data__->TON1);
    __SET_VAR(data__->TOF3.,IN,,__GET_VAR(data__->START_TIMER_DRILL,));
    __SET_VAR(data__->TOF3.,PT,,__time_to_timespec(1, 1200, 0, 0, 0, 0));
    TOF_body__(&data__->TOF3);
    __SET_VAR(data__->TON3.,IN,,__GET_VAR(data__->TOF3.Q,));
    __SET_VAR(data__->TON3.,PT,,__time_to_timespec(1, 1000, 0, 0, 0, 0));
    TON_body__(&data__->TON3);
  }



  goto __end;

__end:
  return;
} // SFC_TEST1_body__() 

// Steps undefinitions
#undef STEP0
#undef __SFC_STEP0
#undef STEP1
#undef __SFC_STEP1
#undef STEP2
#undef __SFC_STEP2
#undef STEP3
#undef __SFC_STEP3
#undef STEP4
#undef __SFC_STEP4
#undef STEP5
#undef __SFC_STEP5
#undef STEP6
#undef __SFC_STEP6
#undef STEP7
#undef __SFC_STEP7
#undef STEP8
#undef __SFC_STEP8
#undef STEP9
#undef __SFC_STEP9
#undef STEP10
#undef __SFC_STEP10
#undef STEP11
#undef __SFC_STEP11
#undef STEP12
#undef __SFC_STEP12
#undef STEP13
#undef __SFC_STEP13
#undef STEP14
#undef __SFC_STEP14
#undef STEP15
#undef __SFC_STEP15
#undef STEP16
#undef __SFC_STEP16
#undef STEP17
#undef __SFC_STEP17
#undef STEP18
#undef __SFC_STEP18
#undef STEP19
#undef __SFC_STEP19
#undef STEP20
#undef __SFC_STEP20
#undef STEP21
#undef __SFC_STEP21

// Actions undefinitions
#undef __SFC_COMPUTE_FUNCTION_BLOCKS
#undef __SFC_Q_CONV1
#undef __SFC_Q_SLIDER1_FORWARD
#undef __SFC_Q_CONV2
#undef __SFC_Q_SLIDER1_BACKWARD
#undef __SFC_Q_MILLING
#undef __SFC_START_TIMER_MILL
#undef __SFC_Q_CONV3
#undef __SFC_Q_DRILLING
#undef __SFC_START_TIMER_DRILL
#undef __SFC_START_TIMER_CONV3
#undef __SFC_Q_SLIDER2_FORWARD
#undef __SFC_Q_CONV4
#undef __SFC_Q_SLIDER2_BACKWARD





